unit StackClass;

interface

uses Windows, SysUtils, Classes;

type
    stekas = ^elem;
    elem = record
        info: integer;
        kitas: stekas
    end;

    Stack = Class (TObject)
               private
                   stack: stekas;
               public
               destructor Destroy; override;
               constructor Create;
               function is_steko(): integer;
               procedure i_steka(i: integer);
               function ieskoti (s: integer): stekas;
               procedure spausdinti;
             end;

implementation

constructor Stack.Create;
begin
  inherited;
end;

destructor Stack.Destroy;
begin
  freeAndNil(stack);
  inherited;
end;

procedure Stack.i_steka(i: integer);
var p: stekas;
begin
   new(p);
   p^.info := i;
   p^.kitas := stack;
   stack := p;
end;

function Stack.is_steko(): integer;
begin
    if stack = nil then
        Write('Stekas tuscias')
    else
    begin
        is_steko := stack^.info;
        stack := stack^.kitas;
    end
end;

function Stack.ieskoti(s: integer): stekas;
var p: stekas;
begin
    ieskoti := nil;
    if stack = nil then
        ieskoti := nil
    else
    begin
        p := stack;
        while (p^.kitas <> nil) do
            if (p^.info = s) then
            begin
                ieskoti := p;
                break;
            end
            else
                p := p^.kitas;
    end
end;

procedure Stack.spausdinti();
var p: stekas;
begin
    if stack <> nil then
    begin
        p := stack;
        while (p <> nil) do
        begin
            WriteLn(p^.info);
            p := p^.kitas;
        end;
    end
end;

end.
